/* @(#)testscpset.c	14.1.1.1 (ES0-DMD) 09/16/99 10:06:08 */
/*===========================================================================
  Copyright (C) 1995 European Southern Observatory (ESO)
 
  This program is free software; you can redistribute it and/or 
  modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of 
  the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public 
  License along with this program; if not, write to the Free 
  Software Foundation, Inc., 675 Massachusetss Ave, Cambridge, 
  MA 02139, USA.
 
  Corresponding concerning ESO-MIDAS should be addressed as follows:
	Internet e-mail: midas@eso.org
	Postal address: European Southern Observatory
			Data Management Division 
			Karl-Schwarzschild-Strasse 2
			D 85748 Garching bei Muenchen 
			GERMANY
===========================================================================*/

 
#include <fileexts.h>
 
 
main()
 
{
 
char	tstflag, file[80], *cpntr;
	
int   null, unit, imno, n, npix[2], mm, naxis, status, first_time, allover;
int   isw, ivals[2], sizze, kk;
char  cunit[40], ident[72]; 
double start[2], step[2];
float  rbuf[160000];
 
SCSPRO("testscpset");

n = SCKRDI("INPUTI",1,2,&mm,ivals,&unit,&null);
n = SCPSET(F_XD_PARM,ivals);

strcpy(file,"scpset");
naxis = 2;
npix[0] = 400; npix[1] = 400;
sizze = npix[0] * npix[1];
n = SCFCRE(file,D_R4_FORMAT,F_O_MODE,F_IMA_TYPE,sizze,&imno);

for (n=0; n<200; n++)
   rbuf[n] = n;

n = SCDWRR(imno,"toto",rbuf,1,200,&unit);
n = SCDWRI(imno,"NAXIS",&naxis,1,1,&unit);
n = SCDWRI(imno,"NPIX",npix,1,2,&unit);
start[0] = 0.0; start[1] = 0.0;
n = SCDWRD(imno,"START",start,1,2,&unit);
step[0] = 1.0; step[1] = 1.0;
n = SCDWRD(imno,"STEP",step,1,2,&unit);
strcpy(cunit,"none ");
n = SCDWRC(imno,"CUNIT",1,cunit,1,32,&unit);
strcpy(ident,"scpset test ");
n = SCDWRC(imno,"IDENT",1,ident,1,72,&unit);

kk = 0;
isw = 0;
for (n=0; n<npix[1]; n++)
   {
   for (mm=0; mm<npix[0]; mm++)
      {
      if (0 <= isw < 8)
         rbuf[kk+mm] = mm;
      else
         rbuf[kk+mm] = npix[0] - mm;
      }

   if (isw == 8) isw = -8;
   isw ++;
   kk += npix[0];
   }

n = SCFPUT(imno,1,sizze,(char *)rbuf);

n = SCFCLO(imno);

SCSEPI();

}

